BtWQuestsDatabase:AddChain(BTWQUESTS_CHAIN_BATTLE_FOR_AZEROTH_SECRETS_BAAL, {
    name = {
        type = "pet",
        id = 2352,
    },
    category = nil,
    expansion = BTWQUESTS_EXPANSION_BATTLE_FOR_AZEROTH,
    range = {110,120},
    completed = {
        type = "pet",
        id = 2352,
    },
    rewards = {
        {
            type = "pet",
            id = 2352,
        },
    },
    items = {
        {
            type = "quest",
            id = 52819,
            name = "Conspicuous Note",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(863, 0.51, 0.59, "Conspicuous Note")
            end,
            x = 3,
            y = 0,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52809,
            name = "Pebble #1",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(646, 0.37, 0.71, "Pebble #1")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52810,
            name = "Pebble #2",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(1161, 0.49, 0.40, "Pebble #2")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52818,
            name = "Pebble #3",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(862, 0.31, 0.35, "Pebble #3")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52817,
            name = "Pebble #4",
            onClick = function ()
                BtWQuests_AddWaypoint(896, 0.3630, 0.5382, "Pebble #4 - In the statue")
                BtWQuests_ShowMapWithWaypoint(896, 0.3499, 0.5487, "Pebble #4 - Cave Entrance")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52816,
            name = "Pebble #5",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(864, 0.6321, 0.2133, "Pebble #5")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52815,
            name = "Pebble #6",
            onClick = function ()
                BtWQuests_AddWaypoint(942, 0.6793, 0.1298, "Pebble #6 - In the wheelbarrow")
                BtWQuests_ShowMapWithWaypoint(942, 0.6683, 0.1476, "Pebble #6 - Cave Entrance")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52814,
            name = "Pebble #7",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(875, 0.5454, 0.073, "Pebble #7")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52813,
            name = "Pebble #8",
            onClick = function ()
                BtWQuests_AddWaypoint(1161, 0.3727, 0.7980, "Pebble #8")
                BtWQuests_ShowMapWithWaypoint(1161, 0.3747, 0.8035, "Pebble #8 - Cave Entrance")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52812,
            name = "Pebble #9",
            onClick = function ()
                BtWQuests_AddWaypoint(896, 0.1715, 0.064, "Pebble #9")
                BtWQuests_ShowMapWithWaypoint(896, 0.1827, 0.0721, "Pebble #9 - Path Start")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 53632,
            name = "Pebble #10",
            onClick = function ()
                BtWQuests_AddWaypoint(895, 0.7429, 0.7087, "Pebble #10")
                BtWQuests_ShowMapWithWaypoint(895, 0.7543, 0.7065, "Pebble #10 - Cave Entrance")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 53633,
            name = "Pebble #11",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(895, 0.8023, 0.1959, "Pebble #11")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 53634,
            name = "Pebble #12",
            onClick = function ()
                BtWQuests_AddWaypoint(895, 0.5970, 0.4184, "Pebble #12")
                BtWQuests_ShowMapWithWaypoint(1161, 0.1001, 0.8259, "Pebble #12 - Cave Entrance")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52827,
            name = "Pebble #13",
            onClick = function ()
                BtWQuests_AddWaypoint(875, 0.5572, -0.1021, "Pebble #13 - Underwater Cave")
                BtWQuests_AddWaypoint(875, 0.477, -0.03, "Pebble #13 - Fatigue Reset Zone")
                BtWQuests_ShowMapWithWaypoint(875, 0.4587, 0.0378, "Pebble #13 - Path Start")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52828,
            name = "Defeat Baa'l",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(525, 0.62, 0.22, "Baa'l")
            end,
            x = 3,
        },
    },
})
-- /run local a,q=0,{{52900,52922}} for x, y in ipairs(q) do for i = y[1], y[2] or y[1], y[3] or 1 do a=a+1 print("Step #"..a.." ("..i.."): "..tostring(IsQuestFlaggedCompleted(i))) end end
-- BtWQuests_ShowMapWithWaypoint(107, 0.4287, 0.4246, "Aldraan")
-- BtWQuests_ShowMapWithWaypoint(111, 0.3613, 0.4370, "Recorder Lidio")
-- BtWQuests_ShowMapWithWaypoint(111, 0.5589, 0.7434, "Scribe Lanloer")
-- BtWQuests_ShowMapWithWaypoint(116, 0.3498, 0.5504, "Aspen Grove Trader")
BtWQuestsDatabase:AddChain(BTWQUESTS_CHAIN_BATTLE_FOR_AZEROTH_SECRETS_WAIST_OF_TIME, {
    name = "Waist of Time",
    category = nil,
    expansion = BTWQUESTS_EXPANSION_BATTLE_FOR_AZEROTH,
    range = {110,120},
    prerequisites = {
        {
            type = "quest",
            id = 52828,
            name = {
                type = "chain",
                id = BTWQUESTS_CHAIN_BATTLE_FOR_AZEROTH_SECRETS_BAAL,
            },
        },
    },
    completed = {
        type = "quest",
        id = 52922,
    },
    rewards = {
        {
            name = function ()
                return string.format(BTWQUESTS_PREFIX, BTWQUESTS_COSMETIC, "Waist of Time")
            end
        }
    },
    items = {
        {
            type = "quest",
            id = 52829,
            name = "Summon Baa'l",
            x = 3,
            y = 0,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52830,
            name = "Lit Orb",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(542, 0.355, 0.32, "Lit Orb")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52831,
            name = "Small Red Strange Seed",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(37, 0.1747, 0.5648, "Small Red Strange Seed")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52898,
            name = "Tiny Frog",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(542, 0.535, 0.1070, "Tiny Frog")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52899,
            name = "Brittle Bone",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(105, 0.336, 0.5810, "Brittle Bone")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52900,
            name = "Misplaced Candle",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(542, 0.68, 0.41, "Misplaced Candle")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52901,
            name = "Odd Cup",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(539, 0.457, 0.26, "Odd Cup")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52902,
            name = "Interesting Rock",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(104, 0.5163, 0.4376, "Interesting Rock")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52903,
            name = "Blooming Lily",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(51, 0.58, 0.3165, "Blooming Lily")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52904,
            name = "Pretty Flower",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(23, 0.24, 0.78, "Pretty Flower")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52905,
            name = "Old Book",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(42, 0.41, 0.79, "Old Book")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52906,
            name = "Dead Fish",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(33, 0.7783, 0.4420, "Dead Fish")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52907,
            name = "Scratched Board",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(47, 0.5199, 0.6234, "Scratched Board")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52908,
            name = "Lost Ring",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(25, 0.446, 0.2634, "Lost Ring")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52909,
            name = "Spoiled Apple",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(15, 0.90, 0.38, "Spoiled Apple")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52910,
            name = "Broken Tooth",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(17, 0.3678, 0.2760, "Broken Tooth")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52911,
            name = "Worn Helm",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(36, 0.2710, 0.4703, "Worn Helm")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52912,
            name = "Leafy Leaf",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(125, 0.4275, 0.2018, "Leafy Leaf")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52913,
            name = "Musty Cloth",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(108, 0.4021, 0.7249, "Musty Cloth")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52914,
            name = "Broken Tablet",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(241, 0.1705, 0.5786, "Broken Tablet")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52915,
            name = "Ashed Torch",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(69, 0.6078, 0.6778, "Ashed Torch")
            end,
            x = 3,
            connections = {
                1,
            },
        },

        {
            type = "quest",
            id = 52916,
            name = "Grimmy's List of Friends",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.85, 0.73, "Grimmy's List of Friends")
            end,
            x = 3,
            connections = {
                1, 2, 3, 4,
            },
        },


        {
            name = "Equip Windwool",
            breadcrumb = true,
            completed = function (item, character)
                return character:IsQuestCompleted(52916) and IsEquippedItem(82397)
            end,
            x = 0,
            connections = {
                4,
            },
        },
        {
            name = "Equip Deathsilk Shoulders",
            breadcrumb = true,
            completed = function (item, character)
                return character:IsQuestCompleted(52916) and IsEquippedItem(54474)
            end,
            connections = {
                3,
            },
        },
        {
            name = "Equip Netherweave Tunic",
            breadcrumb = true,
            completed = function (item, character)
                return character:IsQuestCompleted(52916) and IsEquippedItem(21855)
            end,
            connections = {
                2,
            },
        },
        {
            name = "Equip Frostwoven Leggings",
            breadcrumb = true,
            completed = function (item, character)
                return character:IsQuestCompleted(52916) and IsEquippedItem(41519)
            end,
            connections = {
                1,
            },
        },


        {
            type = "quest",
            id = 52917,
            name = "Talk to Grimmy",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.85, 0.73, "Grimmy")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52918,
            name = "Grimmy's List of Enemies",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.8524, 0.7372, "Grimmy's List of Enemies")
            end,
            x = 3,
            connections = {
                1, 2, 3, 4
            },
        },


        {
            name = "Collect Formula: Enchant Ring - Striking from Karazhan",
            breadcrumb = true,
            completed = function (item, character)
                return character:IsQuestCompleted(52918) and GetItemCount(22535) > 0
            end,
            x = 0,
            connections = {
                4,
            },
        },
        {
            name = "Collect Punctured Pelt from Aspen Grove Trader",
            breadcrumb = true,
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(116, 0.3498, 0.5504, "Aspen Grove Trader")
            end,
            completed = function (item, character)
                return character:IsQuestCompleted(52918) and GetItemCount(40360) > 0
            end,
            connections = {
                4,
            },
        },
        {
            name = "Collect Rough Wooden Staff",
            breadcrumb = true,
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(111, 0.5589, 0.7434, "Scribe Lanloer")
            end,
            completed = function (item, character)
                return character:IsQuestCompleted(52918) and GetItemCount(1515) > 0
            end,
            connections = {
                4,
            },
        },
        {
            name = "Collect Proximo's Rudius from Aldraan",
            breadcrumb = true,
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(107, 0.4287, 0.4246, "Aldraan")
            end,
            completed = function (item, character)
                return character:IsQuestCompleted(52918) and GetItemCount(30569) > 0
            end,
            connections = {
                4,
            },
        },


        {
            type = "quest",
            id = 52822,
            name = "Slap Aquinastrasz",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(241, 0.284, 0.248, "Aquinastrasz")
            end,
            x = 0,
            connections = {
                4,
            },
        },
        {
            type = "quest",
            id = 52823,
            name = "Wave at Karnum Marshweaver",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(66, 0.5746, 0.4773, "Karnum Marshweaver")
            end,
            connections = {
                3,
            },
        },
        {
            type = "quest",
            id = 52824,
            name = "Cheer at Noggra",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(121, 0.4059, 0.6870, "Noggra")
            end,
            connections = {
                2,
            },
        },
        {
            type = "quest",
            id = 52826,
            name = "Dance with Stained Mug",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(379, 0.4443, 0.9030, "Stained Mug")
            end,
            connections = {
                1,
            },
        },


        {
            type = "quest",
            id = 52919,
            name = "Talk to Grimmy",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.85, 0.73, "Grimmy")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52920,
            name = "Grimmy's Favorite Recipe",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.8535, 0.7396, "Grimmy's Favorite Recipe")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            name = "Get to 144 stacks of Rotten Potato",
            breadcrumb = true,
            completed = function (item, character)
                if not character:IsQuestCompleted(52920) then
                    return false
                end

                local index = 1
                local name, _, count, _, _, _, _, _, _, spellId = UnitAura("target", index)
                while name do
                    if spellId == 278475 then
                        return true
                    end
                    index = index + 1
                    name, _, count, _, _, _, _, _, _, spellId = UnitAura("target", index)
                end
            end,
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.8838 , 0.6921, "Rotten Potato")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52921,
            name = "Talk to Grimmy",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.85, 0.73, "Grimmy")
            end,
            x = 3,
            connections = {
                1,
            },
        },
        {
            type = "quest",
            id = 52922,
            name = "Collect the Waist of Time from Grimmy's Rusty Lockbox",
            onClick = function ()
                BtWQuests_ShowMapWithWaypoint(14, 0.8513, 0.7330, "Grimmy's Rusty Lockbox")
            end,
            x = 3,
        },
    },
})

BtWQuestsDatabase:AddCategory(BTWQUESTS_CATEGORY_BATTLE_FOR_AZEROTH_SECRETS, {
    name = BTWQUESTS_SECRET,
    expansion = BTWQUESTS_EXPANSION_BATTLE_FOR_AZEROTH,
    items = {
        {
            type = "chain",
            id = BTWQUESTS_CHAIN_BATTLE_FOR_AZEROTH_SECRETS_BAAL,
        },
        {
            type = "chain",
            id = BTWQUESTS_CHAIN_BATTLE_FOR_AZEROTH_SECRETS_WAIST_OF_TIME,
        },
    },
})

BtWQuestsDatabase:AddExpansionItems(BTWQUESTS_EXPANSION_BATTLE_FOR_AZEROTH, {
    {
        type = "category",
        id = BTWQUESTS_CATEGORY_BATTLE_FOR_AZEROTH_SECRETS,
    },
})